#include "string.h"

/** atob(vp,p,base) converts p to binary result in vp, rtn 1 on success */
atob(vp,p,base)
unsigned int *vp;
char *p;
int base;
{
int r;

if (base == 0) {
	if (p[0] == '0') {
		if (p[1] == 'x') r = _atob(vp,&p[2],16);
		else if (p[1] == 't') r = _atob(vp,&p[2],10);
		else if (p[1] == 'o') r = _atob(vp,&p[2],8);
		else r = _atob(vp,p,8);
		}
	else r = _atob(vp,p,10);
	}
else r = _atob(vp,p,base);
return(r);
}

_atob(vp,p,base)
unsigned int *vp;
char *p;
int base;
{
int digit;
unsigned int value,v1,v2;
char *q,tmp[20];

if (base == 16 && (q=strchr(p,'.')) != 0) {
	if (q-p > 20-1) return(0);
	strncpy(tmp,p,q-p);
	if (!_atob(&v1,tmp,16)) return(0);
	q++;
	if (strchr(q,'.')) return(0);
	if (!_atob(&v2,q,16)) return(0);
	*vp = (v1<<16)+v2;
	return(1);
	}

value = *vp = 0;
for (;*p;p++) {
	value *= base;
	if (*p >= '0' && *p <= '9') digit = *p - '0';
	else if (*p >= 'a' && *p <= 'f') digit = *p - 'a' + 10;
	else if (*p >= 'A' && *p <= 'F') digit = *p - 'A' + 10;
	else return(0);
	if (digit >= base) return(0);
	value += digit;
	}
*vp = value;
return(1);
}

/** char *btoa(dst,value,base) converts value to ascii, result in dst */
char *btoa(dst,value,base)
char *dst;
int base;
unsigned int value;
{
char buf[34],digit;
int i,j,rem,neg;

if (value == 0) {
	dst[0] = '0';
	dst[1] = 0;
	return(dst);
	}

neg = 0;
if (base == 10 && (value&(1L<<31))) {
	value = (~value)+1;
	neg = 1;
	}

for (i=0;value != 0;i++) {
	rem = value % base;
	value /= base;
	if (rem >= 0 && rem <= 9) digit = rem + '0';
	else if (rem >= 10 && rem <= 36) digit = (rem-10) + 'a';
	buf[i] = digit;
	}
buf[i] = 0;
if (neg) strcat(buf,"-");

/* reverse the string */
for (i=0,j=strlen(buf)-1;j>=0;i++,j--) dst[i] = buf[j];
dst[i] = 0;
return(dst);
}

