#include "mips.h"

/*
 * Start-up code for executing a C program under LSI Logic's Prom Monitor 
 */

#define TBLBASE 0xbfc00200


	.globl _exit
	.globl start
	.ent start
start:
	# clear bss
	la	v0,_fbss
	la	v1,end
1:
	sw	zero,0(v0)
	sw	zero,4(v0)
	sw	zero,8(v0)
	sw	zero,12(v0)
	addiu	v0,v0,16
	sltu	t0,v0,v1
	bne	t0,zero,1b

	# set the global data pointer
	la	gp,_gp

	# call the main C routine
	jal	main
_exit:
	li	t0,TBLBASE+(4*8)
	lw	t0,(t0)
	j	t0
	.end start

	.globl read
	.ent read
read:	li	t0,TBLBASE+(4*0)
	lw	t0,(t0)
	j	t0
	.end read

	.globl write
	.ent write
write:	li	t0,TBLBASE+(4*1)
	lw	t0,(t0)
	j	t0
	.end write

	.globl open
	.ent open
open:	li	t0,TBLBASE+(4*2)
	lw	t0,(t0)
	j	t0
	.end open

	.globl close
	.ent close
close:	li	t0,TBLBASE+(4*3)
	lw	t0,(t0)
	j	t0
	.end close

	.globl ioctl
	.ent ioctl
ioctl:	li	t0,TBLBASE+(4*4)
	lw	t0,(t0)
	j	t0
	.end ioctl

	.globl printf
	.ent printf
printf:
	li	t0,TBLBASE+(4*5)
	lw	t0,(t0)
	j	t0
	.end printf

	.globl vsprintf
	.ent vsprintf
vsprintf:
	li	t0,TBLBASE+(4*6)
	lw	t0,(t0)
	j	t0
	.end vsprintf

	.globl ttctl
	.ent ttctl
ttctl:
	li	t0,TBLBASE+(4*7)
	lw	t0,(t0)
	j	t0
	.end ttctl

	.globl getenv
	.ent getenv
getenv:
	li	t0,TBLBASE+(4*9)
	lw	t0,(t0)
	j	t0
	.end getenv

	.globl onintr
	.ent onintr
onintr:
	li	t0,TBLBASE+(4*10)
	lw	t0,(t0)
	j	t0
	.end onintr

	.globl flush_cache
	.ent flush_cache
flush_cache:
	li	t0,TBLBASE+(4*11)
	lw	t0,(t0)
	j	t0
	.end flush_cache
