#define NULL 0
#define ALLOCSIZE 32*1024

static char allocbuf[ALLOCSIZE];
static char *allocp1 = allocbuf;

typedef double ALIGN;

union header {
	struct {
		union header *ptr;
		unsigned size;
	} s;
	ALIGN x;
};

typedef union header HEADER;

static HEADER base;
static HEADER *allocp; /* K&R called allocp, freep */

#define NALLOC 128


#ifdef TEST
/* ---- start of test program ------ */

#define malloc(n)	xmalloc(n)
#define morecore(n)	xmorecore(n)
#define sbrk(n)		xsbrk(n)
#define free(n)		xfree(n)

char *malloc();

main()
{
char *p,buf[40],cmd[40];
unsigned long arg;


for (;;) {
	printf(">");
	gets(buf);
	sscanf(buf,"%s %x",cmd,&arg);
	if (!strcmp(cmd,"alloc")) {
		p = malloc(arg);
		printf("%08x\n",p);
		}
	else if (!strcmp(cmd,"free")) free((char *)arg);
	}
}
/* -------------- end of test code ----------------- */
#endif

/* sbrk() is alloc() on page 101 of K & R  Edition 2 */

char *sbrk(n)
int n;
{
	if (allocp1 + n <= allocbuf + ALLOCSIZE) {
		allocp1 += n;
		return(allocp1 - n);
	} else
		return(NULL);
}


/* The rest of this file is from pages 185-189 of K & R Edition 2 */

char *malloc(nbytes)
unsigned nbytes;
{
	HEADER *morecore();
	register HEADER *p, *q; /* K&R called q, prevp */
	register unsigned nunits;

	nunits = (nbytes + sizeof(HEADER)-1)/sizeof(HEADER)+1;
	if ((q=allocp) == NULL) { /* no free list yet */
		base.s.ptr = allocp = q = &base;
		base.s.size = 0;
	}
	for (p=q->s.ptr; ; q=p, p = p->s.ptr) {
		if (p->s.size >= nunits) { /* big enough */
			if (p->s.size == nunits) /* exactly */
				q->s.ptr = p->s.ptr;
			else {		/* allocate tail end */
				p->s.size -= nunits;
				p += p->s.size;
				p->s.size = nunits;
			}
			allocp = q;
			return((char *) (p+1));
		}
		if (p==allocp)
			if ((p = morecore(nunits)) == NULL)
				return(NULL);
	}
}

static HEADER *morecore(nu)
unsigned nu;
{
	char *sbrk();
	register char *cp;
	register HEADER *up;
	register int rnu;
	
	rnu = NALLOC * ((nu+NALLOC-1) / NALLOC);
	cp = sbrk(rnu * sizeof(HEADER));
	if ((int)cp == NULL)
		return(NULL);
	up = (HEADER *)cp;
	up->s.size = rnu;
	free((char *)(up+1));
	return(allocp);
}


free(ap)
char *ap;
{
	register HEADER *p, *q;

	p = (HEADER *)ap - 1;
	for (q=allocp; !(p > q && p < q->s.ptr); q=q->s.ptr)
		if (q >= q->s.ptr && (p > q || p < q->s.ptr))
			break;
	if (p+p->s.size == q->s.ptr) {
		p->s.size += q->s.ptr->s.size;
		p->s.ptr = q->s.ptr->s.ptr;
	} else
		p->s.ptr = q->s.ptr;
	if (q+q->s.size == p) {
		q->s.size += p->s.size;
		q->s.ptr = p->s.ptr;
	} else
		q->s.ptr = p;
	allocp = q;
}
