#include "stdio.h"
#include "string.h"

#ifdef TEST

main(argc,argv)
int argc;
char *argv[];
{
int r,n;
char *p,buf[80];

if (argc < 3) {
	printf("usage: \n");
	printf("strequ  strcat  strcpy  strchr strlen strichr strdchr\n");
	printf("strlequ strncat strncpy striequ strposn strpat\n");
	printf("strcmp\n");
	exit(1);
	}
	
if (strequ(argv[1],"strequ")) {
	r = strequ(argv[2],argv[3]);
	printf("%d\n",r);
	}
else if (strequ(argv[1],"strcmp")) {
	r = strcmp(argv[2],argv[3]);
	printf("%d\n",r);
	}
else if (strequ(argv[1],"strpat")) {
	r = strpat(argv[2],argv[3]);
	printf("%d\n",r);
	}
else if (strequ(argv[1],"strlequ")) {
	r = strlequ(argv[2],argv[3]);
	printf("%d\n",r);
	}
else if (strequ(argv[1],"striequ")) {
	r = striequ(argv[2],argv[3]);
	printf("%d\n",r);
	}
else if (strequ(argv[1],"strcat")) {
	strcpy(buf,argv[2]);
	p = strcat(buf,argv[3]);
	printf("%s\n",p);
	}
else if (strequ(argv[1],"strposn")) {
	p = strposn(argv[2],argv[3]);
	printf("%s\n",p);
	}
else if (strequ(argv[1],"strncat")) {
	strcpy(buf,argv[2]);
	sscanf(argv[4],"%d",&n);
	p = strncat(buf,argv[3],n);
	printf("%s\n",p);
	}
else if (strequ(argv[1],"strchr")) {
	p = strchr(argv[2],argv[3][0]);
	printf("%s\n",p);
	}
else if (strequ(argv[1],"strncpy")) {
	sscanf(argv[3],"%d",&n);
	p = strncpy(buf,argv[2],n);
	printf("%s\n",p);
	}
else if (strequ(argv[1],"strcpy")) {
	p = strcpy(buf,argv[2]);
	printf("%s\n",p);
	}
else if (strequ(argv[1],"strlen")) {
	n = strlen(argv[2]);
	printf("%d\n",n);
	}
else if (strequ(argv[1],"strichr")) {
	strcpy(buf,argv[2]);
	sscanf(argv[4],"%d",&n);
	p = strichr(&buf[n],argv[3][0]);
	printf("%s\n",p);
	}
else if (strequ(argv[1],"strdchr")) {
	sscanf(argv[3],"%d",&n);
	p = strdchr(&argv[2][n]);
	printf("%s\n",p);
	}
else if (strequ(argv[1],"strnwrd")) {
	n = strnwrd(argv[2]);
	printf("%d\n",n);
	}
else printf("%s: command not found\n",argv[1]);
}
#endif

/** int strbequ(s1,s2) return 1 if s2 matches 1st part of s1 */
int strbequ(s1,s2) 
char *s1,*s2;
{

if (!s1 || !s2) return(0);
for (;*s1 && *s2;s1++,s2++)
	if (*s1 != *s2) return(0);
if (! *s2) return(1);
return(0);
}


/** char *strccat(dst,c)  concatinate char to dst string */
char *strccat(dst,c)
char *dst,c;
{
int len;

if (!dst) return(dst);
len = strlen(dst);
dst[len] = c;
dst[len+1] = 0;
return(dst);
}

/** char *strcat(dst,src)  concatinate src string to dst string */
char *strcat(dst,src) 
char *dst,*src;
{
char *d;

if (!dst || !src) return(dst);
d = dst;
for (;*d;d++) ;
for (;*src;src++) *d++ = *src;
*d = 0;
return(dst);
}

/** char *strncat(dst,src,n) concatinate n chars from src to dst */
char *strncat(dst,src,n) 
char *dst,*src;
int n;
{
char *d;

if (!dst || !src) return(dst);
d = dst;
for (;*d;d++) ;
for (;*src && n;src++,n--) *d++ = *src;
*d = 0;
return(dst);
}

/** char *strchr(p,c) return a ptr to c in p, return NUL if not found */
char *strchr(p,c) 
char *p,c;
{

if (!p) return(0);

for (;*p;p++) if (*p == c) return(p);
return(0);
}

/** char *strrchr(p,c) return a ptr to last c in p, return NUL if not found */
char *strrchr(p,c) 
char *p,c;
{
int i;

if (!p) return(0);

for (i=strlen(p);i>=0;i--) if (p[i] == c) return(&p[i]);
return(0);
}

/** char *strncpy(dst,src,n) copy n chars from src to dst */
char *strncpy(dst,src,n)
char *dst,*src;
int n;
{
char *d;

if (!dst || !src) return(dst);
d = dst;
for (;*src && n;d++,src++,n--) *d = *src;
*d = 0;
return(dst);
}

/** int strequ(s1,s2) return 1 if s1 matches s2 else returns 0 */
int strequ(str1,str2)
char *str1,*str2;
{
	if (!str1 || !str2) return(0);

	while(*str1)
		if(*str1++ != *str2++)
			return(0);
	return(*str2? 0: 1);
}

/** char *strcpy(dst,src) copy src to dst */
char *strcpy(dstp,srcp)
char *dstp,*srcp;
{
	char	*dp = dstp;

	if (!dstp || !srcp) return(dstp);

	while((*dp++ = *srcp++) != '\0')
		;
	return(dstp);
}

/** int strlen(p) returns the length of p */
int strlen(p)
char *p;
{
int n;

if (!p) return(0);
for (n=0;*p;p++) n++;
return(n);
}

/** char *strdchr(p) deletes the first char from the string p */
char *strdchr(p)
char *p;
{
char *t;

if (!p) return(p);
for (t=p;*t;t++) *t = *(t+1);
return(p);
}

/** char *strichr(p,c) inserts c as the first char of the string p */
char *strichr(p,c)
char *p;
int c;
{
char *t;

if (!p) return(p);
for (t=p;*t;t++) ;
for (;t >= p;t--) *(t+1) = *t;
*p = c;
return(p);
}

/** str_fmt(p,size,fmt) format p in a field size in width using fmt */
str_fmt(p,size,fmt)
char *p;
int size,fmt;
{
int n,m,len;

len = strlen(p);
switch (fmt) {
	case FMT_RJUST :
		for (n=size-len;n>0;n--) strichr(p,' ');
		break;
	case FMT_LJUST :
		for (m=size-len;m>0;m--) strcat(p," ");
		break;
	case FMT_RJUST0 :
		for (n=size-len;n>0;n--) strichr(p,'0');
		break;
	case FMT_CENTER :
		m = (size-len)/2;
		n = size - (len+m);
		for (;m>0;m--) strcat(p," ");
		for (;n>0;n--) strichr(p,' ');
		break;
	}
}

/** int striequ(s1,s2) returns 1 if s1 matches s2 ignoring case, else 0 */
int striequ(s1,s2)
char *s1,*s2;
{

if (!s1 || !s2) return(0);
for (;*s1;s1++,s2++) {
	if (toupper(*s1) != toupper(*s2)) return(0);
	}
if (*s2) return(0);
return(1);
}

/** strtoupper(p) convert p to uppercase */
strtoupper(p)
char *p;
{
if (!p) return;
for (;*p;p++) *p = toupper(*p);
}

/** toupper(c) translate c to uppercase */
int toupper(c)
int c;
{

if (islower(c)) return(c - ('a'-'A'));
return(c);
}

/** char *strposn(p,q) returns a ptr to q in p, else 0 if not found */
char *strposn(p,q)
char *p,*q;
{
char *s,*t;

if (!p || !q) return(0);

if (! *q) return(p+strlen(p));
for (;*p;p++) {
	if (*p == *q) {
		t = p; s = q;
		for (;*t;s++,t++) {
			if (*t != *s) break;
			}
		if (! *s) return(p);
		}
	}
return(0);
}

/** int strpat(p,pat) return 1 if pat matches p, else 0; wildcards * and ? */
int strpat(p,pat)
char *p,*pat;
{
char *t,tmp[MAXLN];

if (!p || !pat) return(0);

for (;*p && *pat;) {
	if (*pat == '*') {
		pat++;
		for (t=pat;*t && *t != '*' && *t != '?';t++) ;
		strncpy(tmp,pat,t-pat);
		pat = t;
		t = strposn(p,tmp);
		if (t == 0) return(0);
		p = t + strlen(tmp);
		}
	else if (*pat == '?'|| *pat == *p) { pat++; p++; }
	else return(0);
	}
if (!*p && !*pat) return(1);
if (!*p && *pat == '*' && !*(pat+1)) return(1);
return(0);
}

/** int strcmp(s1,s2) returns +1 if s1 > s2, -1 if s2 > s1, 0 if s1 == s2 */
int strcmp(s1,s2)
char *s1,*s2;
{

if (!s1 || !s2) return(0);

for (;*s1;s1++,s2++) {
	if (*s1 < *s2) return(-1);
	if (*s1 > *s2) return(1);
	}
if (*s2) return(-1);
return(0);
}

/** strempty(p) returns 1 if p contains nothing but isspace */
strempty(p)
char *p;
{

if (!p) return(1);
for (;*p;p++) if (!isspace(*p)) return(0);
return(1);
}

/** char *getword(dst,p) copies next word from p into dst, else rtns 0 */
char *getword(dst,p)
char *p,*dst;
{
char *a;

if (!dst || !p) return(0);

dst[0] = 0;
while (isspace(*p)) p++;
if (*p == 0) return(0);
a = p;
while (!isspace(*p) && *p != 0) p++;
strncpy(dst,a,p-a);
dst[p-a] = 0;
return(p);
}

/* int wordsz(p) return size of first word in p */
int wordsz(p)
char *p;
{
int n;

if (!p) return(0);

while (isspace(*p)) p++;
for (n=0;! *p && ! isspace(*p);n++) p++;
return(n);
}

/** strnwrd(p) returns a count of words in p */
strnwrd(p)
char *p;
{
int n;

if (!p) return(0);

for (n=0;*p;n++) {
	while (isspace(*p)) p++;
	if (! *p) return(n);
	while (!isspace(*p) && *p != 0) p++;
	}
return(n);
}

/** str2cc(p) convert the string p into a control char */
str2cc(p)
char *p;
{
int len;

if (!p) return(0);
len = strlen(p);
if (len < 1 || len > 2) return(0);
if (len == 1) return(p[0]);
if (p[1] < 'A' || p[1] > '~') return(0);
if (p[0] != '^') return(0);
return(p[1]&0x1f);
}

/** char *cc2str(p,c) convert a control char to a string, result in p */
char *cc2str(p,c)
char *p,c;
{

if (iscntrl(c)) {
	p[0] = '^';
	p[1] = c|0x40;
	p[2] = 0;
	}
else {
	p[0] = c;
	p[1] = 0;
	}
return(p);
}

/** stristr(dst,p) insert string p into dst */
stristr(dst,p)
char *dst,*p;
{
int i;

for (i=strlen(p);i>0;i--) strichr(dst++,*p++);
}

/** char *strset(p,set) returns a ptr to 1st char from set in p, else 0 */
char *strset(p,set)
char *p,*set;
{

for (;*p;p++) {
	if (strchr(set,*p)) return(p);
	}
return(0);
}

/** char *strrset(p,set) returns a ptr to last char from set in p, else 0 */
char *strrset(p,set)
char *p,*set;
{
int i;

for (i=strlen(p);i>=0;i--) {
	if (strchr(set,p[i])) return(&p[i]);
	}
return(0);
}

