#include "mips.h"
#include "pmon.h"
#include "stdio.h"
#include "termio.h"
#include "set.h"
#include "string.h"

#define getfield(w,s,p) (((w)&(((1<<s)-1)<<p))>>p)
char *searching = "searching..  ";

char *badhexsym = "%s: neither hex value nor symbol\n";

transp(ac,av)
int ac;
char *av[];
{
int fd,n,i,intrsave;
char *hostport,buf[80],abortch,*trabort;
struct termio tbuf,consave,hostsave;

trabort = getenv("trabort");
abortch = str2cc(trabort);
if (abortch == 0) {
	printf("tr: error: trabort not set\n");
	return;
	}

hostport = getenv("hostport");
if (strequ(hostport,"tty0")) {
	printf("can't use tty0 as hostport in transparent mode\n");
	return;
	}
fd = open(hostport,0);
if (fd == -1) {
	printf("can't open %s\n",hostport);
	return;
	}

printf("Entering transparent mode, %s to abort\n",trabort);

ioctl(fd,TCGETA,&tbuf);
hostsave = tbuf;
tbuf.c_lflag &= ~(ICANON|ECHO|ECHOE);
tbuf.c_iflag &= ~(ICRNL);
tbuf.c_iflag |= IXOFF; /* enable tandem mode */
tbuf.c_oflag &= ~ONLCR;
tbuf.c_cc[4] = 1;
ioctl(fd,TCSETAF,&tbuf);

ioctl(STDIN,TCGETA,&tbuf);
consave = tbuf;
tbuf.c_lflag &= ~(ICANON|ECHO|ECHOE);
tbuf.c_iflag &= ~(ICRNL|IXON);
tbuf.c_oflag &= ~ONLCR;
tbuf.c_cc[4] = 1;
ioctl(STDIN,TCSETAF,&tbuf);

/* disable INTR char */
ioctl(STDIN,GETINTR,&intrsave);
ioctl(STDIN,SETINTR,0);

for (;;) {
	ioctl(STDIN,FIONREAD,&n);
	if (n > 0) {
		n = read(STDIN,buf,n);
		if (strchr(buf,abortch)) break;
		write(fd,buf,n);
		}
	ioctl(fd,FIONREAD,&n);
	if (n > 0) {
		n = read(fd,buf,n);
		write(STDOUT,buf,n);
		}
	}
ioctl(STDIN,TCSETAF,&consave);
ioctl(fd,TCSETAF,&hostsave);
ioctl(STDIN,SETINTR,&intrsave);
}

modify(ac,av)
int ac;
char *av[];
{
	word a,adr = cur_adr, i;
	byte c, *p;
	byte wr_only = 0;

	if(1 < ac)
		if(!get_rsa(&adr,av[1])) return(1);
	if(2 < ac){
		for(i = 2; i < ac; i++){
			if (strequ(av[i],"-s")) {
				i++;
				if (i >= ac) printf("bad arg count\n");
				else {
					for (p=av[i];*p;p++) 
						save_byte(adr++,*p);
					}
			}
			else {
				if(!get_rsa(&a,av[i])) return(1);
				c = a;
				save_byte(adr++, c);
			}
		}
	}else{
		while(1){
			printf("%08x ",adr);
			if(wr_only) printf("  ");
			else printf("%02x",load_byte(adr));
			putchar(SP);
			gets(line);
			for(p = line; *p == SP; p++) ;
			if(!*p || htob(p,&c)){
				if(*p == '.') break;
				else if(*p == '^' || *p == '-') --adr;
				else if(*p != '=') ++adr;
				}
			else save_byte(adr++, c);
		}
	}
	return(0);
}

search(ac,av)
int ac;
char *av[];
{
	uword from, to, adr, i,a;
	byte *s, *d, c;
	char prnbuf[LINESZ];
	int siz,ln,cnt;

	if (!atob(&siz,getenv("moresz"),10)) {
		printf("%s: bad moresz value\n",getenv("moresz"));
		return(1);
		}
	ln = siz;
	cnt = TIKRATE*256;
	ioctl(STDIN,CBREAK,NULL);

	if(!get_rsa(&from,av[1]) || !get_rsa(&to,av[2])) return(1);
	for(d = pattern, i = 3; i < ac; i++){
		if (strequ(av[i],"-s")) {
			i++;
			if (i >= ac) printf("bad arg count\n");
			else for (s=av[i];*s;s++) *d++ = *s;
			}
		else {
			if(!get_rsa(&a,av[i])) return(1);
			c = a;
			*d++ = c;
		}
	}

	printf("%s",searching);
	if(from <= to){ /* forward search */
		to -= d - pattern - 1;
		while(from <= to){
			s = pattern, adr = from++;
			while(s < d){
				if(*s != load_byte(adr)) break;
				s++, adr++;
			}
			if(d <= s) {
				era_line(searching);
				dispmem(prnbuf,from - 1); 
				if (more(prnbuf,&ln,siz)) break;
				printf("%s",searching);
				}
			else {
				cnt--;
				if (! cnt) cnt = dotik(TIKRATE*256);
				}
		}
	if (from > to) era_line(searching);
	}else{ /* backward search */
		from -= d - pattern - 1;
		while(to <= from){
			s = pattern, adr = from--;
			while(s < d){
				if(*s != load_byte(adr)) break;
				s++, adr++;
			}
			if(d <= s) {
				era_line(searching);
				dispmem(prnbuf,from - 1); 
				if (more(prnbuf,&ln,siz)) break;
				printf("%s",searching);
				}
		}
	if (to > from) era_line(searching);
	}
	return(0);
}

call(ac,av)
int ac;
char *av[];
{
int i,j,k;
char *arg[10];

arg[0] = 0;
k = 0;
for (i=1;i<ac;i++) {
	if (av[i][0] == '-') {
		j = 1;
		while (av[i][j] != 0) {
			if (av[i][j] == 's') {
				i++;
				if (i >= ac) printf("bad arg count\n");
				else arg[k++] = av[i];
				break;
				}
			else printf("%c: unknown option\n",av[i][j]);
			j++;
			}
		}
	else {
		if (!get_rsa(&arg[k],av[i])) return;
		k++;
		}
	}
if (arg[0] != 0) (((Func *)arg[0]))(arg[1],arg[2],arg[3],arg[4],arg[5]);
else printf("Function address not specified\n");
}

flush_cache(type,adr)
int type;
word adr;
{
if (IS_K1SEG(adr)) return;

switch(type) {
	case ICACHE :
#ifdef LR33000
#   ifdef SABLE
		r3k_iflush();
#   else
		r33k_iflush();
#   endif
#else
		r3k_iflush();
#endif
		break;
	case DCACHE :
#ifdef LR33000
#   ifdef SABLE
		r3k_dflush();
#   else
		r33k_dflush();
#   endif
#else
		r3k_dflush();
#endif
		break;
	case IADDR :
#ifdef LR33000
#   ifdef SABLE
		r3k_iaflush(adr);
#   else
		r33k_iaflush(adr);
#   endif
#else
		r3k_iaflush(adr);
#endif
		break;
	}
}

iflush(ac,av)
int ac;
char *av[];
{

flush_cache(ICACHE);
return(0);
}

dflush(ac,av)
int ac;
char *av[];
{

flush_cache(DCACHE);
return(0);
}

void
save_word(word adr,word v)
{
*(word *)adr = v;
flush_cache(IADDR,adr);
}

void
save_half(word adr, half v)
{
*(half *)adr = v;
flush_cache(IADDR,adr);
}

void
save_byte(word adr, byte v)
{
*(byte *)adr = v;
flush_cache(IADDR,adr);
}

byte *dump_byte(byte *dst, byte val){
	static char Hextab[] = "0123456789ABCDEF";

	*dst++ = Hextab[(val >> 4) & 0xf];
	*dst++ = Hextab[(val >> 0) & 0xf];
	chksum += val;	/* must be here */
	return(dst);
}

void sfmt_dump(byte *dst, byte *src, word siz, word adr, byte fmt){
	chksum = 0;
	*dst++ = 'S', *dst++ = fmt;
	switch(fmt){
	case '1': case '2': case '3':
		dst = dump_byte(dst, siz + 3 + (fmt - '1'));
		break;
	case '7': case '8': case '9':
		dst = dump_byte(dst, siz + 3 + (fmt - '7'));
		break;
	}
	switch(fmt){
	case '3': case '9':
		dst = dump_byte(dst, adr >> 24);
		/* fall */
	case '2': case '8':
		dst = dump_byte(dst, adr >> 16);
		/* fall */
	case '1': case '7':
		dst = dump_byte(dst, adr >> 8);
		dst = dump_byte(dst, adr >> 0);
		break;
	case '0': /* not yet */
	default:
		*dst = '\0';
		return;
	}
	while(siz-- > 0)
		dst = dump_byte(dst, *src++);
	dst = dump_byte(dst, ~chksum);
	*dst++ = '\n';
	*dst = '\0';
}

sdump(ac,av)
int ac;
char *av[];
{
	uword	adr, siz, len, i, a;
	byte	*p;
	char *uleof,*ulcr;
	int fd;
	struct termio tbuf;

	if(!get_rsa(&adr,av[1]) || !get_rsa(&siz,av[2])) return(1);
	fd = open(getenv("hostport"),0);
	if (fd == -1) {
		printf("can't open %s\n",getenv("hostport"));
		return(1);
		}
	ioctl(fd,TCGETA,&tbuf);
	tbuf.c_iflag &= ~IXANY; 
	ioctl(fd,TCSETAF,&tbuf);

	uleof = getenv("uleof");
	ulcr = getenv("ulcr");

	while(0 < siz){
		len = (siz < 16)? siz: 16;
		for(a = adr, p = pattern, i = 0; i < len; a++, p++, i++)
			*p = load_byte(a);
		sfmt_dump(line, pattern, len, adr, '3');
		if (strequ(ulcr,"on")) line[strlen(line)-1] = '\r';
		write(fd,line,strlen(line));
		adr += len;
		siz -= len;
	}
	sfmt_dump(line, pattern, 0, 0, '7');
	if (strequ(ulcr,"on")) line[strlen(line)-1] = '\r';
	write(fd,line,strlen(line));
	write(fd,uleof,strlen(uleof));
	return(0);
}

copy(ac,av)
int ac;
char *av[];
{
	uword from, to, n;

	if(!get_rsa(&from,av[1]) || !get_rsa(&to,av[2]) || !get_rsa(&n,av[3]))
		return(1);
	if(to < from)
		while(n-- > 0)
			save_byte(to++, load_byte(from++));
	else
		for(from += n, to += n; n-- > 0; )
			save_byte(--to, load_byte(--from));
	return(0);
}

dump(ac,av)
int ac;
char *av[];
{
word adr = cur_adr, siz, l;
byte v,prnbuf[LINESZ];

if(ac >= 2)
	if(!get_rsa(&adr,av[1])) return(1);

if(ac == 3) {
	if(!get_rsa(&siz,av[2])) return(1);
	}
else {
	if (!atob(&siz,getenv("moresz"),10)) {
		printf("%s: bad moresz value\n",getenv("moresz"));
		return(1);
		}
	}

ioctl(STDIN,CBREAK,NULL);
l = siz;
while(1) {
	adr = dispmem(prnbuf,adr);
	if (more(prnbuf,&l,(ac > 2)?0:siz)) break;
	}
}

word dispmem(p,adr)
char *p;
word adr;
{
int i;
byte v;
char tmp[4];
unsigned char buf[16];
word w;

w = adr;
for(i = 0; i < 16 ; i++){
	v = load_byte(w++);
	buf[i] = v;
	}

sprintf(p,"%08x  ",adr);
for(i = 0; i < 16 ; i++){
	sprintf(tmp,"%02x ",buf[i]);
	strcat(p,tmp);
	if(i == 7) strccat(p,' ');
	}
strcat(p,"  ");
for(i = 0; i < 16 ; i++){
	v = buf[i];
	if (isprint(v)) strccat(p,v);
	else strccat(p,'.');
	}
return(adr+16);
}

fill(ac,av)
int ac;
char *av[];
{
	uword from, to, i,a;
	byte *s, *d, c;

	if(!get_rsa(&from,av[1]) || !get_rsa(&to,av[2])) return(1);
	if(to < from)
		return(1);
	for(d = pattern, i = 3; i < ac; i++){
		if (strequ(av[i],"-s")) {
			i++;
			if (i >= ac) printf("bad arg count\n");
			else for (s=av[i];*s;s++) *d++ = *s;
			}
		else {
			if(!get_rsa(&a,av[i])) return(1);
			c = a;
			*d++ = c;
		}
	}
	for(s = pattern; from <= to; from++){
		save_byte(from, *s);
		if(d <= ++s)
			s = pattern;
	}
	return(0);
}

int argvize(av,s)
char *av[];
byte *s;
{
byte **pav = av, c;
int ac;

	for(ac = 0; ac < MAX_AC; ac++){
		/* step over cntrls and spaces */
		while(*s && *s <= SP) ++s;

		/* if eos quit */
		if(!*s) break;

		c = *s;
		/* if it's a quote skip forward */
		if(c == SQ || c == DQ) {
			*pav++ = ++s;
			while(*s && *s != c) ++s;
			if(*s) *s++ = 0;
			}
		else { /* find end of word */
			*pav++ = s;
			while(SP < *s) ++s;
			}

		/* not eos inc ptr */
		if(*s) *s++ = 0;
	}
return(ac);
}

get_rsa(vp,p)
unsigned long *vp;
char *p;
{
int r,inbase,inalpha;
unsigned long v1,v2;
char *q,subexpr[LINESZ];

if (q=strrset(p,"+-")) { /* is compound */
	strncpy(subexpr,p,q-p);
	r = get_rsa(&v1,subexpr);
	if (r == 0) return(r);
	r = get_rsa(&v2,q+1);
	if (r == 0) return(r);
	if (*q == '+') *vp = v1 + v2;
	else *vp = v1 - v2;
	return(1);
	}

if (q=strrset(p,"*/")) { 
	strncpy(subexpr,p,q-p);
	r = get_rsa(&v1,subexpr);
	if (r == 0) return(r);
	r = get_rsa(&v2,q+1);
	if (r == 0) return(r);
	if (*q == '*') *vp = v1 * v2;
	else *vp = v1 / v2;
	return(1);
	}

if (*p == '@') {
	r = getreg(vp,&p[1]);
	if (r == 0) printf("%s: bad register name\n",&p[1]);
	}
else if (strequ(p,".")) {
	r = getreg(vp,"epc");
	if (r == 0) printf("%s: bad register name\n",&p[1]);
	}
else if (*p == '&') {
	r = sym2adr(vp,&p[1]);
	if (r == 0) printf("%s: bad symbol name\n",&p[1]);
	}
else if (isdigit(*p)) {
	inbase = matchenv("inbase");
	if (inbase == TEN) r = atob(vp,p,10);
	else if (inbase == SIXTEEN) r = atob(vp,p,16);
	else if (inbase == EIGHT) r = atob(vp,p,8);
	else if (inbase == AUTO) r = atob(vp,p,0);
	else {
		printf("%s: bad inbase value\n",getenv("inbase"));
		return(0);
		}
	if (r == 0) {
		r = atob(vp,p,0);
		if (r == 0) printf("%s: bad base %s value\n",
						p,getenv("inbase"));
		}
	}
else if (isxdigit(*p)) {
	inalpha = matchenv("inalpha");
	if (inalpha == HEX) {
		r = atob(vp,p,16);
		if (r == 0) {
			r = sym2adr(vp,p);
			if (r == 0) printf(badhexsym,p);
			}
		}
	else if (inalpha == SYMBOL) {
		r = sym2adr(vp,p);
		if (r == 0) {
			r = atob(vp,p,16);
			if (r == 0) printf(badhexsym,p);
			}
		}
	else {
		printf("%s: bad inalpha value\n",getenv("inalpha"));
		return(0);
		}
	}
else {
	r = sym2adr(vp,p);
	if (r == 0) printf("%s: bad symbol name\n",p);
	}
return(r);
}


