#include "mips.h"
#include "stdio.h"
#include "termio.h"
#include "pmon.h"

memtst(ac,av)
int ac;
char *av[];
{
int cflag,siz;
unsigned int *adr;

cflag = 0;
adr = (unsigned int *)0xa0020000;
siz = 0x000e0000; /* 1Meg - PMON data space */

if (ac == 3) {
	if (!get_rsa(&siz,av[2])) return;
	if (!get_rsa(&adr,av[1])) return;
	}
else if (ac == 2) {
	if (!get_rsa(&siz,av[1])) return;
	}

if (siz == 0) {
	siz = 0x000e0000; /* 1Meg - PMON data space */
	cflag = 1;
	}

/* make sure the address is word aligned */
adr = (unsigned int *)(((unsigned int)adr) & ~0x3);

siz &= ~0x3;	/* make sure it's an exact number of words */

ioctl(STDIN,CBREAK,NULL);

printf("Memory test running..  ");
if (cflag) for (;;) domt(adr,siz);
else domt(adr,siz);

}

domt(adr,siz)
unsigned int *adr;
int siz;
{
int i,j,err,cnt,rate;
unsigned int w,*p,r;

err = 0;
rate = TIKRATE*256;
cnt = rate;

/* walking ones test */
for (p=adr,i=0;i<siz;i+=4,p++) {
	w = 1;
	for (j=0;j<32;j++) {
		*p = w;
		r = *p;
		if (r != w) {
			err++;
			printf("\b\nerror: addr=%08x read=%08x expected=%08x  ",
				p,r,w);
			}
		w <<= 1;
		cnt--;
		if (!cnt) cnt = dotik(rate);
		}
	}

/* store the address in each address */
for (p=adr,i=0;i<siz;i+=4,p++) {
	*p = (unsigned int)p;
	cnt--;
	if (!cnt) cnt = dotik(rate);
	}

/* check that each address contains its address */
for (p=adr,i=0;i<siz;i+=4,p++) {
	r = *p;
	if (r != (unsigned int)p) {
		err++;
		printf("\b\nerror: adr=%08x read=%08x expected=%08x  ",p,r,p);
		}
	cnt--;
	if (!cnt) cnt = dotik(rate);
	}

if (err) printf("\b\nThere were %d errors.\n",err);
else printf("\b\nTest passed with no errors.\n");
}

