#include "stdio.h"
#include "termio.h"
#include "mips.h"
#include "pmon.h"

#define BEL 007

char more_pat[LINESZ];
int more_cnt;
char more_tiks[] = "|/-\\";
char *more_tik;
char *more_msg = "more... ";

#ifdef PMCC
/* ---------------- Start of test program ---------------------- */
main(ac,av)
int ac;
char *av[];
{
char prnbuf[80];
int siz,ln,i,j,len,sflag;

siz = 0;
len = 9999;
sflag = 0;
for (i=1;i<ac;i++) {
	if (av[i][0] == '-') {
		for (j=1;av[i][j] != 0;j++) {
			if (av[i][j] == 'l') {
				i++;
				if (i >= ac) {
					printf("bad arg count\n");
					exit(1);
					}
				if (!atob(&len,av[i],0)) {
					printf("%s: bad value\n",av[i]);
					exit(1);
					}
				break;
				}
			else if (av[i][j] == 's') sflag = 1;
			else printf("%c: unknown flag\n",av[i][j]);
			}
		}
	else if (isdigit(av[i][0])) {
		if(!atob(&siz,av[i],0)) {
			printf("%s: bad value\n",av[i]);
			exit(1);
			}
		}
	else printf("%s: unknown option\n",av[i]);
	}

if (siz == 0) {
	if (!atob(&siz,getenv("moresz"),10)) {
		printf("%s: bad moresz value\n",getenv("moresz"));
		return(1);
		}
	}

ioctl(STDIN,CBREAK,NULL);
ln = siz;
for (i=0;i<len;i++) {
	mkline(prnbuf,i);
	if (more(prnbuf,&ln,((sflag)?0:siz))) break;
	}
}

mkline(p,n)
char *p;
int n;
{
int i;

sprintf(p,"%d:",n);
p = &p[strlen(p)];

for (i='0';i<='z';i++) *p++ = i;
*p = 0;
}
/* ---------------- End of test program ---------------------- */
#endif

more(p,cnt,size)
char *p;
int *cnt,size;
{
int r;

if (*cnt == 0) {
	if (size == 0) return(1); /* if cnt=0 and size=0 we're done */
	while ((r = getinp(cnt,size)) == -1) ;
	if (r) return(1); /* quit */
	}

if (*cnt == -1) { /* search in progress */
	if (!strposn(p,more_pat)) {
		more_cnt--;
		if (! more_cnt) more_cnt = dotik(TIKRATE);
		return(0); /* not found yet */
		}
	else { /* found */
		*cnt = size;
		printf("\b \n");
		}
	}

printf("%s\n",p);
(*cnt)--;
return(0);
}

getinp(cnt,size)
int *cnt,size;
{
int i,c;

printf("%s",more_msg);
loop {
	c = getchar();
	if (strchr("nq/ \n",c)) break;
	putchar(BEL);
	}
era_line(more_msg);
if (c == 'q') return(1);
switch (c) {
	case ' ' : *cnt = size; 	break;
	case '\n': *cnt = 1;		break;
	case '/' : 
		/* get pattern */
		putchar('/');
		for (i=0;;) {
			c = getchar();
			if (c == '\n') break;
			if (c == '\b') {
				if (i > 0) {
					putchar(c);
					i--;
					}
				else {
					putchar('\b');
					return(-1);
					}
				}
			else {
				putchar(c);
				more_pat[i++] = c;
				}
			}
		more_pat[i] = 0;
		printf("  ");
		more_cnt = TIKRATE;
		*cnt = -1; /* enter search mode */
		break;
	case 'n' : 
		printf("/%s  ",more_pat);
		*cnt = -1; /* enter search mode */
		more_cnt = TIKRATE;	
		break;
	}
return(0);
}

dotik(rate)
int rate;
{

if (more_tik == 0) more_tik = more_tiks;
if (*more_tik == 0) more_tik = more_tiks;
printf("\b%c",*more_tik);
more_tik++;
return(rate);
}

