#include "mips.h"
#include "pmon.h"
#include "string.h"

struct envstr {
	char *name;
	char *init;
	char *value;
	char *values;
	};

struct envstr envvar[] = {
	{"brkcmd","l @epc 1",0,0},
	{"datasz","-b",0,"-b -h -w"},
	{"dlecho","off",0,"off on lfeed"},
	{"dlproto","EtxAck",0,"none XonXoff EtxAck"},
	{"dltype","srec",0,"srec fast"},
	{"hostport","tty1",0,0},
	{"inalpha","hex",0,"hex symbol"},
	{"inbase","16",0,"auto 8 10 16"},
	{"moresz","10",0,0},
	{"prompt","PMON> ",0,0},
	{"regstyle","sw",0,"hw sw"},
	{"rptcmd","trace",0,"off on trace"},
	{"trabort","^K",0,0},
	{"uleof","%",0,0},
	{"ulcr","off",0,"off on"},
	{0}};

envinit()
{
int i;
char buf[LINESZ];

/* set defaults */
for (i=0;envvar[i].name != 0;i++) {
	sprintf(buf,"set %s '%s'",envvar[i].name,envvar[i].init);
	do_cmd(buf);
	}

newsym("Pmon",0x9fc00000);
newsym("start",0x80020000);

for (i=0;demo[i].name != 0;i++) {
	sprintf(buf,"sym %s %08x",demo[i].name,demo[i].addr);
	do_cmd(buf);
	}
}

do_set(ac,av)
int ac;
char *av[];
{
int i;

switch (ac) {
	case 1 : /* display all variables */
		for (i=0;envvar[i].name;i++) {
			printvar(i);
			}
		break;
	case 2 : /* display specific variable */
		for (i=0;envvar[i].name;i++)
			if (strequ(av[1],envvar[i].name)) break;
		if (envvar[i].name) printvar(i);
		else printf("%s: not found\n",av[1]);
		break;
	case 3 : /* set specific variable */
		for (i=0;envvar[i].name;i++)
			if (strequ(av[1],envvar[i].name)) break;
		if (envvar[i].name) {
			if (envvar[i].value) free(envvar[i].value);
			envvar[i].value = malloc(strlen(av[2])+1);
			strcpy(envvar[i].value,av[2]);
			}
		else printf("%s: not found\n",av[1]);
		break;
	}
}

printvar(i)
int i;
{

if (envvar[i].value == 0) 
	printf("%10s = %-10s",envvar[i].name,"UNDEFINED");
else if (strchr(envvar[i].value,' ')) 
	printf("%10s = \"%s\"",envvar[i].name,envvar[i].value);
else 
	printf("%10s = %-10s",envvar[i].name,envvar[i].value);
if (envvar[i].values) printf("  [%s]",envvar[i].values);
printf("\n");
}

/** char *getenv(name) returns pointer to current value of named variable */
char *getenv(p)
char *p;
{
int i;

for (i=0;envvar[i].name;i++)
	if (strequ(p,envvar[i].name)) break;

if (envvar[i].value == 0) {
	envvar[i].value = malloc(2);
	strcpy(envvar[i].value,"");
	}
return(envvar[i].value);
}

/** matchenv(name) returns integer corresponding to current value */
matchenv(name)
char *name;
{
int i,j;
char *t,wrd[20];

for (i=0;envvar[i].name;i++)
	if (strequ(name,envvar[i].name)) break;
if (!envvar[i].name) return(-1);

if (envvar[i].value == 0) {
	envvar[i].value = malloc(2);
	strcpy(envvar[i].value,"");
	}

for (j=0,t=envvar[i].values;;j++) {
	t = getword(wrd,t);
	if (t == 0) return(-2);
	if (striequ(wrd,envvar[i].value)) return(j);
	}
}

